/* com.cintegrity.Lib.Collection.BaseObjectSetMap.i
&TypeName   Name of type of key, e.g., String or Integer
&Type       Variable type of key, e.g., character or integer
&Pre        Prefix for type of key, e.g., ch or in
&Class      Set or List
*/
class com.cintegrity.Lib.Collection.{&TypeName}Object{&Class}Map
    implements com.cintegrity.Lib.Collection.BaseMap
    :
  define private temp-table ctt_{&Class}
      field {&Pre}_Key as {&Type}
&IF ( "{&Class}" = "List" )
&THEN
      field in_Seq as integer
&ENDIF
      field ob_AnObject as class Progress.Lang.Object
&IF ( "{&Class}" = "List" )
&THEN
      index by_Key as primary unique {&Pre}_Key in_Seq
&ELSE
      index by_Key as primary unique {&Pre}_Key
&ENDIF
      index by_Object ob_AnObject.
  define private variable cin_Count as integer no-undo initial 0.
&IF ( "{&TypeName}" = "Object" )
&THEN
  define private variable c{&Pre}_FirstKey as {&Type} no-undo.
  define private variable c{&Pre}_LastKey as {&Type} no-undo.
  define private variable c{&Pre}_CurrentKey as {&Type} no-undo.
&ELSE
  define private variable c{&Pre}_FirstKey as {&Type} no-undo initial ?.
  define private variable c{&Pre}_LastKey as {&Type} no-undo initial ?.
  define private variable c{&Pre}_CurrentKey as {&Type} no-undo initial ?.
&ENDIF
&IF ( "{&Class}" = "List" )
&THEN
  define private variable cin_CurrentSeq as integer no-undo initial 0.
&ENDIF

  destructor public {&TypeName}Object{&Class}Map():
&IF ( "{&TypeName}" = "Object" )
&THEN
    for each ctt_{&Class}:
      delete object ctt_{&Class}.{&Pre}_Key.
      delete object ctt_{&Class}.ob_AnObject.
    end.
    empty temp-table ctt_{&Class}.
    if valid-object( c{&Pre}_CurrentKey ) then delete object cob_CurrentKey.
    if valid-object( c{&Pre}_FirstKey ) then delete object cob_FirstKey.
    if valid-object( c{&Pre}_LastKey ) then delete object cob_LastKey.
&ELSE
    for each ctt_{&Class}:
      delete object ctt_{&Class}.ob_AnObject.
    end.
    empty temp-table ctt_{&Class}.
&ENDIF
  end destructor.
  /* ---------------------------------- start of implement BaseMap interface */
  method public integer size():
    return cin_Count.
  end method.

  method public logical isEmpty():
    return ( cin_Count = 0 ).
  end method.

  method public logical containsValue(
      input mob_Value as class Progress.Lang.Object
      ):
    find first ctt_{&Class}
        where ctt_{&Class}.ob_AnObject EQ mob_Value
        no-error.
    return available( ctt_{&Class} ).
  end method.

  method public void clearAll():
&IF ( "{&TypeName}" = "Object" )
&THEN
message "A" view-as alert-box.
    for each ctt_{&Class}:
      if valid-object( ctt_{&Class}.{&Pre}_Key ) then delete object ctt_{&Class}.{&Pre}_Key.
      if valid-object( ctt_{&Class}.ob_AnObject ) then delete object ctt_{&Class}.ob_AnObject.
    end.
    empty temp-table ctt_{&Class}.
    if valid-object( c{&Pre}_CurrentKey ) then delete object cob_CurrentKey.
    if valid-object( c{&Pre}_FirstKey ) then delete object cob_FirstKey.
    if valid-object( c{&Pre}_LastKey ) then delete object cob_LastKey.
&ELSE
    for each ctt_{&Class}:
      delete object ctt_{&Class}.ob_AnObject.
    end.
    empty temp-table ctt_{&Class}.
&ENDIF
    cin_Count = 0.
  end method.

  /* -------------------------------------------------- Implementation deferred
  method public class com.cintegrity.util.SortedSet keySet():

  end method.

  method public class com.cintegrity.util.Collection values():

  end method.

  method public class com.cintegrity.util.SortedSet entrySet():

  end method.
  -------------------------------------------------------------------------- */

  method public logical hasNextKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key GT c{&Pre}_CurrentKey
          no-error.
      return available( ctt_{&Class} ).
    end.
    else return false.
  end method.

  method public class Progress.Lang.Object getNextValue():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key GT c{&Pre}_CurrentKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
&IF ( "{&Class}" = "List" )
&THEN
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
&ENDIF
        return ctt_{&Class}.ob_AnObject.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public logical hasPrevKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key LT c{&Pre}_CurrentKey
          no-error.
      return available( ctt_{&Class} ).
    end.
    else return false.
  end method.

  method public class Progress.Lang.Object getPrevValue():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      for each ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key LT c{&Pre}_CurrentKey
          by ctt_{&Class}.{&Pre}_Key descending
          :
        leave.
      end.
      if available( ctt_{&Class} )
      then do:
        c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
&IF ( "{&Class}" = "List" )
&THEN
        find first ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_CurrentKey
            .
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
&ENDIF
        return ctt_{&Class}.ob_AnObject.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public class Progress.Lang.Object getFirstValue():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_FirstKey )
&ELSE
    if c{&Pre}_FirstKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_FirstKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
&IF ( "{&Class}" = "List" )
&THEN
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
&ENDIF
        return ctt_{&Class}.ob_AnObject.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public class Progress.Lang.Object getLastValue():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_LastKey )
&ELSE
    if c{&Pre}_LastKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_LastKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
&IF ( "{&Class}" = "List" )
&THEN
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
&ENDIF
        return ctt_{&Class}.ob_AnObject.
      end.
      else return ?.
    end.
    else return ?.
  end method.
  /* ------------------------------------ end of implement BaseMap interface */

  method public logical containsKey(
      input m{&Pre}_Key as {&Type}
      ):
    find first ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        no-error.
    return available( ctt_{&Class} ).
  end method.

  method public {&Type} getFirstKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_FirstKey )
&ELSE
    if c{&Pre}_FirstKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_FirstKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        return c{&Pre}_FirstKey.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public {&Type} getLastKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_LastKey )
&ELSE
    if c{&Pre}_LastKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_LastKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        return c{&Pre}_LastKey.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public {&Type} getNextKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key GT c{&Pre}_CurrentKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        return ctt_{&Class}.{&Pre}_Key.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public {&Type} getPrevKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      for each ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key LT c{&Pre}_CurrentKey
          by ctt_{&Class}.{&Pre}_Key descending
          :
        leave.
      end.
      if available( ctt_{&Class} )
      then do:
        return ctt_{&Class}.{&Pre}_Key.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public {&Type} getCurrentKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_CurrentKey
          no-error.
      if available( ctt_{&Class} )
      then do:
        return c{&Pre}_CurrentKey.
      end.
      else return ?.
    end.
    else return ?.
  end method.

  method public class Progress.Lang.Object getValue(
      input m{&Pre}_Key as {&Type}
      ):
    find first ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        no-error.
    if available( ctt_{&Class} )
    then do:
      c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
&IF ( "{&Class}" = "List" )
&THEN
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
&ENDIF
      return ctt_{&Class}.ob_AnObject.
    end.
    else return ?.
  end method.
&IF ( "{&Class}" = "List" )
&THEN
  method public integer countOfKey(
      input m{&Pre}_Key as {&Type}
      ):
    define variable min_Count as integer no-undo initial 0.
    for each ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        :
      min_Count = min_Count + 1.
    end.
    return min_Count.
  end method.

  method public integer getCurrentSeq():
    return cin_CurrentSeq.
  end.

  method public integer numberOfKeys():
    define variable min_Count as integer no-undo.
    define variable m{&Pre}_CurrentKey as {&Type} no-undo.
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_FirstKey )
&ELSE
    if c{&Pre}_FirstKey NE ?
&ENDIF
    then do:
      min_Count = 0.
      find first ctt_{&Class} no-error.
      do while available( ctt_{&Class} ):
        min_Count = min_Count + 1.
        m{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
        find first ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key GT m{&Pre}_CurrentKey
            no-error.
      end.
    end.
    return min_Count.
  end method.

  method public class Progress.Lang.Object getNextValueSameKey():
&IF ( "{&TypeName}" = "Object" )
&THEN
    if valid-object( cob_CurrentKey )
&ELSE
    if c{&Pre}_CurrentKey NE ?
&ENDIF
    then do:
      find first ctt_{&Class}
          where ctt_{&Class}.{&Pre}_Key EQ c{&Pre}_CurrentKey
          and   ctt_{&Class}.in_Seq GT cin_CurrentSeq
          no-error.
      if available( ctt_{&Class} )
      then do:
        cin_CurrentSeq = ctt_{&Class}.in_Seq.
        return ctt_{&Class}.ob_AnObject.
      end.
      else return ?.
    end.
    else return ?.
  end method.
&ENDIF

&IF ( "{&Class}" = "List" )
&THEN
  method public void putValue(
&ELSE
  method public class Progress.Lang.Object putValue(
&ENDIF
      input m{&Pre}_Key as {&Type},
      input mob_Value as class Progress.Lang.Object
      ):
&IF ( "{&Class}" = "List" )
&THEN
    find last ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        no-error.
    if available( ctt_{&Class} )
    then do:
      cin_CurrentSeq = ctt_{&Class}.in_Seq + 1.
    end.
    else do:
      cin_CurrentSeq = 1.
    end.
    cin_Count = cin_Count + 1.
&ELSE
    define variable mob_OldValue as class Progress.Lang.Object no-undo.
                                                       /* enforce uniqueness */
    find first ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        no-error.
    if available( ctt_{&Class} )
    then do:
      mob_OldValue = ctt_{&Class}.ob_AnObject.
      delete ctt_{&Class}.
    end.
    else do:
      assign
          mob_OldValue = ?
          cin_Count = cin_Count + 1
          .
    end.
&ENDIF
    create ctt_{&Class}.
    assign
        ctt_{&Class}.{&Pre}_Key = m{&Pre}_Key
&IF ( "{&Class}" = "List" )
&THEN
        ctt_{&Class}.in_Seq = cin_CurrentSeq
&ENDIF
        ctt_{&Class}.ob_AnObject = mob_Value
        c{&Pre}_CurrentKey = m{&Pre}_Key
        .
    if     c{&Pre}_LastKey LT c{&Pre}_CurrentKey
        or c{&Pre}_LastKey EQ ?
    then c{&Pre}_LastKey = c{&Pre}_CurrentKey.
    if     c{&Pre}_FirstKey GT c{&Pre}_CurrentKey
        or c{&Pre}_FirstKey EQ ?
    then c{&Pre}_FirstKey = c{&Pre}_CurrentKey.
&IF ( "{&Class}" = "Set" )
&THEN
    return mob_OldValue.
&ENDIF
  end method.

&IF ( "{&Class}" = "List" )
&THEN
  method public void removeValue(
      input m{&Pre}_Key as {&Type},
      input min_Seq as integer
      ):
    find first ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        and   ctt_{&Class}.in_Seq EQ min_Seq
        no-error.
    if available( ctt_{&Class} )
    then do:
      cin_Count = cin_Count - 1.
      delete ctt_{&Class}.
      if m{&Pre}_Key NE c{&Pre}_FirstKey
      then do:
        for each ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
            and   ctt_{&Class}.in_Seq LT min_Seq
            by ctt_{&Class}.{&Pre}_Key descending
            :
          leave.
        end.
        if not available( ctt_{&Class} )
        then do:
          for each ctt_{&Class}
              where ctt_{&Class}.{&Pre}_Key LT m{&Pre}_Key
              by ctt_{&Class}.{&Pre}_Key descending
              :
            leave.
          end.
        end.
        if available( ctt_{&Class} )
        then do:
          c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
          cin_CurrentSeq = ctt_{&Class}.in_Seq.
          if m{&Pre}_Key EQ c{&Pre}_LastKey
          then c{&Pre}_LastKey = c{&Pre}_CurrentKey.
        end.
        else do:
          assign
               c{&Pre}_CurrentKey = ?
               cin_CurrentSeq = 0
               .
        end.
      end.
      else do:
        find first ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
            and   ctt_{&Class}.in_Seq LT min_Seq
            no-error.
        if not available( ctt_{&Class} )
        then do:
          find first ctt_{&Class}
              where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
              and   ctt_{&Class}.in_Seq GT min_Seq
              no-error.
        end.
        if not available( ctt_{&Class} )
        then do:
          find first ctt_{&Class}
              where ctt_{&Class}.{&Pre}_Key GT m{&Pre}_Key
              no-error.
        end.
        if available( ctt_{&Class} )
        then do:
          c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
          cin_CurrentSeq = ctt_{&Class}.in_Seq.
          c{&Pre}_FirstKey = c{&Pre}_CurrentKey.
        end.
        else do:
          assign
               c{&Pre}_CurrentKey = ?
               cin_CurrentSeq = 0
               .
        end.
      end.
    end.
  end method.
&ELSE
  method public class Progress.Lang.Object removeValue(
      input m{&Pre}_Key as {&Type}
      ):
    define variable mob_OldValue as class Progress.Lang.Object no-undo.
    find first ctt_{&Class}
        where ctt_{&Class}.{&Pre}_Key EQ m{&Pre}_Key
        no-error.
    if available( ctt_{&Class} )
    then do:
      mob_OldValue = ctt_{&Class}.ob_AnObject.
      cin_Count = cin_Count - 1.
      delete ctt_{&Class}.
      if m{&Pre}_Key NE c{&Pre}_FirstKey
      then do:
        for each ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key LT m{&Pre}_Key
            by ctt_{&Class}.{&Pre}_Key descending
            :
          leave.
        end.
        if available( ctt_{&Class} )
        then do:
          c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
          if m{&Pre}_Key EQ c{&Pre}_LastKey
          then c{&Pre}_LastKey = c{&Pre}_CurrentKey.
        end.
        else c{&Pre}_CurrentKey = ?.
      end.
      else do:
        find first ctt_{&Class}
            where ctt_{&Class}.{&Pre}_Key GT m{&Pre}_Key
            no-error.
        if available( ctt_{&Class} )
        then do:
          c{&Pre}_CurrentKey = ctt_{&Class}.{&Pre}_Key.
          c{&Pre}_FirstKey = c{&Pre}_CurrentKey.
        end.
        else c{&Pre}_CurrentKey = ?.
      end.
    end.
    return mob_OldValue.
  end method.
&ENDIF
  /* -------------------------------------------------- Implementation deferred
  method public void putAll(
      input mob_Map as class com.cintegrity.Lib.Collection.Map
      ):

  end method.
  -------------------------------------------------------------------------- */

end class.
